#region Copyright Syncfusion Inc. 2001 -2004
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
//  Copyright Syncfusion Inc. All rights reserved. Use of this code is subject to the terms of our 
//  license. A copy of the current license can be obtained at any time by e-mailing licensing@syncfusion.com. 
//  Re-distribution in any form is strictly prohibited. Any infringement will be prosecuted under applicable laws. 
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
#endregion 
 
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;

namespace CustomersSample
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridRecordNavigationControl gridRecordNavigationControl1;
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		private System.Windows.Forms.Button okButton;
		private System.Windows.Forms.Button _cancelButton;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.DataGrid dataGrid1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//Listen to the IBindingList.ListChanged events instead of the 
			//CurrencyManager events.
			this.gridDataBoundGrid1.UseListChangedEvent = true;
			this.gridDataBoundGrid1.OptimizeInsertRemoveCells = true;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridRecordNavigationControl1 = new Syncfusion.Windows.Forms.Grid.GridRecordNavigationControl();
			this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			this.okButton = new System.Windows.Forms.Button();
			this._cancelButton = new System.Windows.Forms.Button();
			this.button1 = new System.Windows.Forms.Button();
			this.dataGrid1 = new System.Windows.Forms.DataGrid();
			this.gridRecordNavigationControl1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridRecordNavigationControl1
			// 
			this.gridRecordNavigationControl1.AllowAddNew = false;
			this.gridRecordNavigationControl1.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.gridRecordNavigationControl1.Controls.AddRange(new System.Windows.Forms.Control[] {
																									   this.gridDataBoundGrid1});
			this.gridRecordNavigationControl1.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Bold);
			this.gridRecordNavigationControl1.Location = new System.Drawing.Point(24, 24);
			this.gridRecordNavigationControl1.MaxRecord = 0;
			this.gridRecordNavigationControl1.Name = "gridRecordNavigationControl1";
			this.gridRecordNavigationControl1.ShowToolTips = true;
			this.gridRecordNavigationControl1.Size = new System.Drawing.Size(504, 137);
			this.gridRecordNavigationControl1.SplitBars = Syncfusion.Windows.Forms.DynamicSplitBars.Both;
			this.gridRecordNavigationControl1.TabIndex = 0;
			this.gridRecordNavigationControl1.Text = "gridRecordNavigationControl1";
			this.gridRecordNavigationControl1.ThemesEnabled = true;
			// 
			// gridDataBoundGrid1
			// 
			this.gridDataBoundGrid1.AllowDragSelectedCols = true;
			this.gridDataBoundGrid1.FillSplitterPane = true;
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.ThemesEnabled = true;
			// 
			// okButton
			// 
			this.okButton.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
			this.okButton.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.okButton.Location = new System.Drawing.Point(448, 321);
			this.okButton.Name = "okButton";
			this.okButton.Size = new System.Drawing.Size(56, 24);
			this.okButton.TabIndex = 1;
			this.okButton.Text = "&OK";
			this.okButton.Click += new System.EventHandler(this.okButton_Click);
			// 
			// _cancelButton
			// 
			this._cancelButton.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
			this._cancelButton.CausesValidation = false;
			this._cancelButton.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this._cancelButton.Location = new System.Drawing.Point(336, 321);
			this._cancelButton.Name = "_cancelButton";
			this._cancelButton.Size = new System.Drawing.Size(56, 24);
			this._cancelButton.TabIndex = 2;
			this._cancelButton.Text = "&Cancel";
			this._cancelButton.Click += new System.EventHandler(this.cancelButton_Click);
			// 
			// button1
			// 
			this.button1.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
			this.button1.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.button1.Location = new System.Drawing.Point(32, 321);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(40, 24);
			this.button1.TabIndex = 3;
			this.button1.Text = "Test";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// dataGrid1
			// 
			this.dataGrid1.Anchor = ((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.dataGrid1.DataMember = "";
			this.dataGrid1.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dataGrid1.Location = new System.Drawing.Point(24, 176);
			this.dataGrid1.Name = "dataGrid1";
			this.dataGrid1.Size = new System.Drawing.Size(504, 112);
			this.dataGrid1.TabIndex = 4;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(560, 374);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.dataGrid1,
																		  this.button1,
																		  this._cancelButton,
																		  this.okButton,
																		  this.gridRecordNavigationControl1});
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.gridRecordNavigationControl1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		CustomerCollection customers;
		private void Form1_Load(object sender, System.EventArgs e)
		{
			customers = PopulateCustomers.CreateCustomers(); 
			this.gridDataBoundGrid1.Binder.SetDataBinding(customers, "");
			GridHierarchyLevel childrenLevel = this.gridDataBoundGrid1.Binder.AddRelation("Children");
			childrenLevel.ShowHeaders = false;
			this.gridDataBoundGrid1.Binder.RootHierarchyLevel.ShowHeaders = true;
			this.dataGrid1.DataSource = customers;

			this.gridDataBoundGrid1.RowExpanded += new GridRowEventHandler(gridDataBoundGrid1_RowExpanded);
			this.gridDataBoundGrid1.RowCollapsed += new GridRowEventHandler(gridDataBoundGrid1_RowCollapsed);
		}

		private void cancelButton_Click(object sender, System.EventArgs e)
		{
			Close();
		}

		private void okButton_Click(object sender, System.EventArgs e)
		{
			Close();
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			CustomerCollection customers = this.gridDataBoundGrid1.DataSource as CustomerCollection;
			customers[0].FirstName = "zzzz";
			customers[0].EndEdit();

			customers[0].Children[0].FirstName = "ccccc";
			customers[0].Children[0].EndEdit();

			customers[0].Children[1].FirstName = "ddddd";
			customers[0].Children[1].EndEdit();
		}

		
		private void gridDataBoundGrid1_RowExpanded(object sender, GridRowEventArgs e)
		{
			GridBoundRecordState rs = this.gridDataBoundGrid1.Binder.GetRecordStateAtRowIndex(e.RowIndex);
			if(rs.ChildList != null)
			{
				CustomerCollection list = (CustomerCollection)rs.ChildList;
				list.ListChanged += new ListChangedEventHandler(list_ListChanged);
			}
		}

		private void gridDataBoundGrid1_RowCollapsed(object sender, GridRowEventArgs e)
		{
			GridBoundRecordState rs = this.gridDataBoundGrid1.Binder.GetRecordStateAtRowIndex(e.RowIndex);
			if(rs.ChildList != null)
			{
				CustomerCollection list = (CustomerCollection)rs.ChildList;
				list.ListChanged -= new ListChangedEventHandler(list_ListChanged);
			}
		}

		 

		private void list_ListChanged(object sender, ListChangedEventArgs e)
		{
			if(e.ListChangedType == ListChangedType.ItemChanged)
			{
				for(int i = this.gridDataBoundGrid1.TopRowIndex; i <= this.gridDataBoundGrid1.ViewLayout.LastVisibleRow; ++i)
				{
					GridBoundRecordState rs = this.gridDataBoundGrid1.Binder.GetRecordStateAtRowIndex(i);
					if(rs.ChildList.Equals(sender))
					{
						this.gridDataBoundGrid1.RefreshRange(GridRangeInfo.Row(i + e.NewIndex + 1));
						break;
					}
				}
			}
		}
	}
}
